Ginkgo: gko::factorization::ParIlut< ValueType, IndexType > Class Template Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::factorization::ParIlut< ValueType, IndexType > Class Template Reference
Linear Operators » Factorizations | Linear Operators

ParILUT is an incomplete threshold-based LU factorization which is computed in parallel. More...

`#include <ginkgo/core/factorization/par_ilut.hpp>`

Inheritance diagram for gko::factorization::ParIlut< ValueType, IndexType >:
[legend]
Collaboration diagram for gko::factorization::ParIlut< ValueType, IndexType >:
[legend]

## Classes
struct | parameters_type
class | Factory

## Public Types
using | value_type = ValueType
using | index_type = IndexType
using | matrix_type = matrix::Csr<ValueType, IndexType>
using | l_matrix_type = matrix_type
using | u_matrix_type = matrix_type
Public Types inherited from gko::Composition< default_precision >
using | value_type
using | transposed_type
Public Types inherited from gko::EnablePolymorphicAssignment< Composition< default_precision > >
using | result_type

## Public Member Functions
std::shared_ptr< const matrix_type > | get_l_factor () const
std::shared_ptr< const matrix_type > | get_u_factor () const
const parameters_type & | get_parameters () const
Public Member Functions inherited from gko::Composition< default_precision >
const std::vector< std::shared_ptr< const LinOp > > & | get_operators () const noexcept
| Returns a list of operators of the composition.
std::unique_ptr< LinOp > | transpose () const override
| Returns a LinOp representing the transpose of the Transposable object.
std::unique_ptr< LinOp > | conj_transpose () const override
| Returns a LinOp representing the conjugate transpose of the Transposable object.
Composition & | operator= (const Composition &)
| Copy-assigns a Composition.
| Composition (const Composition &)
| Copy-constructs a Composition.
Public Member Functions inherited from gko::EnableLinOp< Composition< default_precision > >
const Composition< default_precision > * | apply (ptr_param< const LinOp > b, ptr_param< LinOp > x) const
Public Member Functions inherited from gko::EnablePolymorphicAssignment< Composition< default_precision > >
void | convert_to (result_type *result) const override
void | move_to (result_type *result) override

## Static Public Member Functions
template<typename... Args>
static std::unique_ptr< Composition< ValueType > > | create (Args &&... args)=delete
static auto | build () -> decltype(Factory::create())
static parameters_type | parse (const config::pnode &config, const config::registry &context, const config::type_descriptor &td_for_child=config::make_type_descriptor< ValueType, IndexType >())
| Create the parameters from the property_tree.
Static Public Member Functions inherited from gko::EnableCreateMethod< Composition< default_precision > >
static std::unique_ptr< Composition< default_precision > > | create (Args &&... args)

## Detailed Description

template<typename ValueType = default_precision, typename IndexType = int32>
class gko::factorization::ParIlut< ValueType, IndexType >

ParILUT is an incomplete threshold-based LU factorization which is computed in parallel.

is a lower unitriangular, while is an upper triangular matrix, which approximate a given matrix with . Here, and have a sparsity pattern that is improved iteratively based on their element-wise magnitude. The initial sparsity pattern is chosen based on the factorization of .

One iteration of the ParILUT algorithm consists of the following steps:

1. Calculating the residual
2. Adding new non-zero locations from to and . The new non-zero locations are initialized based on the corresponding residual value.
3. Executing a fixed-point iteration on and according to For a more detailed description of the fixed-point iteration, see ParIlu.
4. Removing the smallest entries (by magnitude) from and
5. Executing a fixed-point iteration on the (now sparser) and

This ParILUT algorithm thus improves the sparsity pattern and the approximation of and simultaneously.

The implementation follows the design of H. Anzt et al., ParILUT - A Parallel Threshold ILU for GPUs, 2019 IEEE International Parallel and Distributed Processing Symposium (IPDPS), pp. 231–241.

Template Parameters

  ValueType | Type of the values of all matrices used in this class
  IndexType | Type of the indices of all matrices used in this class

## Member Function Documentation

## ◆ parse()

template<typename ValueType = default_precision, typename IndexType = int32>

parameters_type gko::factorization::ParIlut< ValueType, IndexType >::parse | ( | const config::pnode & | config,
|  | const config::registry & | context,
|  | const config::type_descriptor & | td_for_child = config::make_type_descriptor< ValueType, IndexType >() )
| static

Create the parameters from the property_tree.

Because this is directly tied to the specific type, the value/index type settings within config are ignored and type_descriptor is only used for children configs.

Parameters

  config | the property tree for setting
  context | the registry
  td_for_child | the type descriptor for children configs. The default uses the value/index type of this class.

Returns
  parameters

References gko::Composition< default_precision >::Composition().

The documentation for this class was generated from the following file:

- ginkgo/core/factorization/par_ilut.hpp